#include <stdlib.h>
#include "fxlib.h"

#include "affichage.h"
#include "fonctions.h"
#include "struc.h"
#include "gray.h"

#include "fonctionsaffich.h"

int afficher(Doodle *doodle, Plate *listePlates, PlateFake *listeFakes, Autres *autres, unsigned char contrast, unsigned int fps)
{
	int i,j;
	unsigned char ligne = 126;

	Screen *screen;

	screen = gray_getScreen();
	doodle->x = doodle->saut.origine + doodle->saut.hauteur - doodle->posCamera;

	afficher_plateformes(listePlates, doodle->posCamera);
	afficher_fakes(listeFakes, doodle->posCamera);

	TraceImg(doodle->x, doodle->y, doodle->dernierAppui, doodle->bouclier, doodle->ball.active, doodle->saut.modeSaut);
	draw_ball(doodle->ball, doodle->posCamera);
	if(autres->mob.hauteurReelle)
		afficher_mobs(autres, doodle->posCamera);
	if(doodle->dead)
		draw_etoiles(doodle);


	ML_vertical_line_buffer(120, 0, 64, BLACK, screen->VRAM2);
	ML_rectangle_buffer(121, 0, 128, 64, 0, WHITE, WHITE, screen->VRAM2);



	afficher_nombres_buffer(doodle->score, 122, 2, screen->VRAM1);
	afficher_nombres_buffer(doodle->score, 122, 2, screen->VRAM2);


	afficher_nombres_buffer(contrast, 122, 50, screen->VRAM1);
	afficher_nombres_buffer(contrast, 122, 50, screen->VRAM2);


	afficher_nombres_buffer( fps, 122, 22, screen->VRAM1);
	afficher_nombres_buffer( fps, 122, 22, screen->VRAM2);



	j = doodle->posCamera/16*16;
	for(i=0; i<136; i+=16)// affichage des traits sur les bords
	{
		ML_bmp_or_cl_buffer(&ligne, j+i -doodle->posCamera, 0, 8, 1, screen->VRAM2);
		ML_bmp_or_cl_buffer(&ligne, j+i -doodle->posCamera, 63, 8, 1, screen->VRAM2);
	}

}

void afficher_fakes(PlateFake* liste, int camera)
{
	PlateFake *tmp;
	unsigned char fake1[] = {96,240,240,240,160,160,80,80,240,240,240,96};
	unsigned char fake2[] = {56,120,176,32,64,0,0,64,32,176,120,56};
	Screen *screen;
	screen = gray_getScreen();

	tmp = liste;
	while(tmp)
	{
		if(tmp->actif)
		{
			ML_bmp_or_cl_buffer(fake1, tmp->origine - camera-tmp->position, tmp->y, 4, 12, screen->VRAM1);
			//ML_bmp_or_buffer(fake2, 90, 10, 5, 12, screen->VRAM1);
		}
		tmp = tmp->nxt;
	}

}
void afficher_plateformes(Plate* listePlates, int camera)
{
	int x, i, j;
	unsigned char plateforme[] = {96, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 96};
	unsigned char ressort[] = {64, 192, 64};
	unsigned char ponctuelleVRAM2[] = {96, 144, 144, 144, 144, 144, 144, 144, 144, 144, 144, 96};
	unsigned char ponctuelleVRAM1[] = {0, 96, 96, 96, 96, 96, 96, 96, 96, 96, 96, 0};
	unsigned short jetPackVRAM2[] = { 65472, 32864, 65472, 8448, 65472, 32864, 65472 };
	unsigned short jetPackVRAM1[] = { 32640, 32640, 32640, 0, 32640, 32640, 32640 };

	unsigned char bouclierVRAM1[] = {7,240,24,8,32,6,67,242,71,225,143,225,159,241,159,249,159,249,144,17,136,33,68,33,67,242,32,6,24,8,7,240};
	unsigned char bouclierVRAM2[] = {0,0,0,0,0,0,3,240,4,32,8,32,16,16,31,248,31,248,31,240,15,224,7,224,3,240,0,0,0,0,0,0};
	Plate *tmp;
	Screen *screen;

	tmp = listePlates;
	screen = gray_getScreen();

    while(tmp) // Tant que l'on n'est pas au bout de la liste
    {
        x = tmp->x - camera;
		if(x<128)
		{
			if(tmp->mode == PONCTUELLE)
			{
				ML_bmp_or_cl_buffer(ponctuelleVRAM1, x, tmp->y, HAUTEUR_PLATEFORME, LARGEUR_PLATEFORME, screen->VRAM1);
				ML_bmp_or_cl_buffer(ponctuelleVRAM2, x, tmp->y, HAUTEUR_PLATEFORME, LARGEUR_PLATEFORME, screen->VRAM2);
			}
			else if(tmp->mode == TEMPORISEE)
			{
				if(tmp->positionTempo > 0)
				{
					for(i=0; i<4; i++)
					{
						for(j=0; j<12; j++)
						{
							if(tmp->pixelsTempo[12*i+j] == 1)
								ML_pixel_buffer(x+i, tmp->y+j, BLACK, screen->VRAM1);
						}
					}
				}
				else
					ML_bmp_or_cl_buffer(plateforme, x, tmp->y, HAUTEUR_PLATEFORME, LARGEUR_PLATEFORME, screen->VRAM1);
			}
			else// plateforme normale
			{
				ML_bmp_or_cl_buffer(plateforme, x, tmp->y, HAUTEUR_PLATEFORME, LARGEUR_PLATEFORME, screen->VRAM1);
				ML_bmp_or_cl_buffer(plateforme, x, tmp->y, HAUTEUR_PLATEFORME, LARGEUR_PLATEFORME, screen->VRAM2);

			}
			if(tmp->ressort==1)
			{
				ML_bmp_or_cl_buffer(ressort, x+HAUTEUR_PLATEFORME, tmp->y+1, 2, 3, screen->VRAM1);
				ML_bmp_or_cl_buffer(ressort, x+HAUTEUR_PLATEFORME, tmp->y+1, 2, 3, screen->VRAM2);
			}
			else if(tmp->ressort == 2)
			{
				ML_bmp_or_cl_buffer(ressort, x+HAUTEUR_PLATEFORME, tmp->y+8, 2, 3, screen->VRAM1);
				ML_bmp_or_cl_buffer(ressort, x+HAUTEUR_PLATEFORME, tmp->y+8, 2, 3, screen->VRAM2);
			}
			else if(tmp->mode == JETPACK)
			{
				ML_bmp_or_cl_buffer((unsigned char*)jetPackVRAM1, x+HAUTEUR_PLATEFORME, tmp->y +3, 11, 7, screen->VRAM1);
				ML_bmp_or_cl_buffer((unsigned char*)jetPackVRAM2, x+HAUTEUR_PLATEFORME, tmp->y +3, 11, 7, screen->VRAM2);
			}

			if(tmp->bouclier)
			{
				ML_bmp_or_buffer(bouclierVRAM1, x+HAUTEUR_PLATEFORME, tmp->y-2, 16, 16, screen->VRAM1);
				ML_bmp_or_buffer(bouclierVRAM2, x+HAUTEUR_PLATEFORME, tmp->y-2, 16, 16, screen->VRAM2);
			}
		}

        tmp = tmp->nxt;
    }
}


void TraceImg(int x, int y, int dernierAppui, int bouclier, int tire, Mode_Saut modeSaut)
{
	unsigned short centreVRAM1[] = { 16256, 61408, 12272, 61424, 12272, 61424, 12272, 61408, 16256 };
	unsigned short centreVRAM2[] = { 15360, 63520, 14384, 63504, 14352, 63504, 14384, 63520, 15360 };
	unsigned short centreBG[] = {49264, 16, 49152, 0, 49152, 0, 49152, 16, 49264};
	unsigned char  droiteVRAM2[] = {120, 8, 0, 0, 0, 32, 0, 32, 8, 144, 144, 96, 144};
	unsigned char  droiteVRAM1[] = {120, 8, 0, 0, 0, 32, 0, 32, 8, 240, 240, 96, 144};
	unsigned char  gaucheBG[] = {104, 152, 8, 8, 240, 216, 248, 216, 248, 248, 248, 240, 128};
	unsigned char  droiteBG[] = {128, 240, 248, 248, 248, 216, 248, 216, 240, 8, 8, 152, 104};
	unsigned char  gaucheVRAM2[] = {144, 96, 144, 144, 8, 32, 0, 32, 0, 0, 0, 8, 120};
	unsigned char  gaucheVRAM1[] = {144, 96, 240, 240, 8, 32, 0, 32, 0, 0, 0, 8, 120};
	unsigned short tireVRAM1[] = { 16320, 61408, 12273, 61438, 12284, 61438, 12273, 61408, 16320 };
	unsigned short tireVRAM2[] = { 16320, 63584, 14385, 63774, 14340, 63774, 14385, 63584, 16320 };

	unsigned short jetPackVolDroiteVRAM2[] = { 49152, 61440, 65534, 64515, 65534, 61664, 49152};
	unsigned short jetPackVolDroiteVRAM1[] = { 0, 0, 4094, 4095, 4094, 224, 0 };

	unsigned short jetPackVolGaucheVRAM2[] = { 49152, 61664, 65534, 64515, 65534, 61440, 49152 };
	unsigned short jetPackVolGaucheVRAM1[] = { 0, 224, 4094, 4095, 4094, 0, 0 };
	Screen *screen;

	screen = gray_getScreen();


	if(bouclier)
	{
		ML_filled_circle_buffer(x+5, y+4, 10, BLACK, screen->VRAM1);
		ML_circle_buffer(x+5, y+4, 10, WHITE, screen->VRAM1);
		ML_circle_buffer(x+5, y+4, 10, BLACK, screen->VRAM2);

	}
	ML_bmp_and_cl_buffer((unsigned char*)centreBG, x, y, 12, 9, screen->VRAM1);
	ML_bmp_and_cl_buffer((unsigned char*)centreBG, x, y, 12, 9, screen->VRAM2);

	if (!tire)
	{
		if(dernierAppui == DROITE)
		{
			ML_bmp_and_cl_buffer(droiteBG, x+5, y, 5, 13, screen->VRAM1);
			ML_bmp_and_cl_buffer(droiteBG, x+5, y, 5, 13, screen->VRAM2);
			ML_bmp_or_cl_buffer(droiteVRAM1, x+5, y, 5, 13, screen->VRAM1);
			ML_bmp_or_cl_buffer(droiteVRAM2, x+5, y, 5, 13, screen->VRAM2);
		}
		else
		{
			ML_bmp_and_cl_buffer(gaucheBG, x+5, y-4, 5, 13, screen->VRAM1);
			ML_bmp_and_cl_buffer(gaucheBG, x+5, y-4, 5, 13, screen->VRAM2);
			ML_bmp_or_cl_buffer(gaucheVRAM1, x+5, y-4, 5, 13, screen->VRAM1);
			ML_bmp_or_cl_buffer(gaucheVRAM2, x+5, y-4, 5, 13, screen->VRAM2);
		}
	}
	else
	{
		ML_bmp_or_cl_buffer((unsigned char *)tireVRAM1, x, y, 16, 9, screen->VRAM1);
		ML_bmp_or_cl_buffer((unsigned char *)tireVRAM2, x, y, 16, 9, screen->VRAM2);
	}
	if(modeSaut == JET)
	{
		if(dernierAppui == DROITE)
		{
			ML_bmp_or_cl_buffer((unsigned char*)jetPackVolDroiteVRAM1, x-3, y-6, 16, 7, screen->VRAM1);
			ML_bmp_or_cl_buffer((unsigned char*)jetPackVolDroiteVRAM2, x-3, y-6, 16, 7, screen->VRAM2);
		}
		else
		{
			ML_bmp_or_cl_buffer((unsigned char*)jetPackVolGaucheVRAM1, x-3, y+8, 16, 7, screen->VRAM1);
			ML_bmp_or_cl_buffer((unsigned char*)jetPackVolGaucheVRAM2, x-3, y+8, 16, 7, screen->VRAM2);
		}
	}
	ML_bmp_or_cl_buffer((unsigned char*)centreVRAM1, x, y, 12, 9, screen->VRAM1);
	ML_bmp_or_cl_buffer((unsigned char*)centreVRAM2, x, y, 12, 9, screen->VRAM2);

}


void afficher_mobs(Autres *autres, int camera)
{
	unsigned char  mob1VRAM1[] = {48,0,0,78,0,0,79,254,0,32,63,128,48,127,192,19,255,224,20,127,240,20,127,240,19,252,248,112,124,121,128,125,127,128,125,60,176,188,60,81,63,255,16,191,253,16,127,252,16,127,254,16,127,254,16,255,222,49,127,254,32,255,254,32,127,254,32,126,255,32,124,126,96,125,62,128,125,63,131,252,60,98,126,60,34,63,255,33,63,253,16,255,248,16,31,240,16,31,224,48,31,192,64,32,0,79,192,0,80,0,0,48,0,0};
	unsigned char  mob1VRAM2[] = {48,0,0,126,0,0,127,254,0,63,227,128,63,192,192,31,192,96,28,64,48,28,67,16,31,196,152,127,196,73,255,197,79,255,197,36,255,164,36,95,35,199,31,160,5,31,192,4,31,192,6,31,192,114,31,192,82,63,64,114,63,192,2,63,193,130,63,194,195,63,196,98,127,197,34,255,197,39,255,196,36,126,66,36,62,33,199,63,32,13,31,224,24,31,240,48,31,240,96,63,255,192,127,224,0,127,192,0,112,0,0,48,0,0};
	unsigned short mob2VRAM1[] = { 224, 1016, 1028, 2044, 520, 1016, 272, 496, 25072, 41979, 40958, 50140, 32766, 2046, 2047, 2046, 32766, 50140, 40958, 41979, 25072, 496, 272, 1016, 520, 2044, 1028, 1016, 224 };
	unsigned short mob2VRAM2[] = { 224, 792, 2044, 1028, 1016, 520, 496, 272, 25072, 58123, 65126, 65108, 31858, 1794, 1027, 1794, 31858, 65108, 65126, 58123, 25072, 272, 496, 520, 1016, 1028, 2044, 792, 224 };
	unsigned short mob3VRAM1[] = { 8064, 32753, 49150, 47612, 16383, 14734, 16302, 14734, 32735, 47612, 49150, 8161 };
	unsigned short mob3VRAM2[] = { 8064, 24689, 42766, 44804, 10099, 12170, 10154, 12170, 26451, 44836, 42782, 8161 };
	unsigned char  mob4VRAM1[] = {0,112,0,3,136,0,4,8,0,6,8,0,65,8,12,128,136,62,143,254,222,117,87,12,21,85,96,117,87,240,143,255,96,128,137,0,65,8,134,6,8,127,4,8,15,3,136,6,0,112,0};
	unsigned char  mob4VRAM2[] = {0,112,0,3,248,0,7,248,0,7,248,0,65,248,12,128,248,50,143,254,210,122,171,12,26,171,96,122,171,144,143,255,96,128,249,0,65,248,134,7,248,121,7,248,9,3,248,6,0,112,0};
	unsigned short mob5VRAM1[] = { 2648, 12232, 16376, 16376, 65148, 49150, 16382, 16383, 16334, 65534, 49151, 16254, 16188, 16382, 28664,20472,3064,4390,6576};
	unsigned short mob5VRAM2[] = { 2648, 12232, 13368, 9608, 59332, 42370, 9218, 9267, 9338, 58418, 42115, 9670, 9700, 13766, 27656, 19464, 3064, 4390, 6576 };
	unsigned short mob6VRAM1[] = { 3296, 2176, 2176, 1216, 17376, 33296, 33854, 31807, 3135, 31807, 33854, 34320, 17376, 1216, 2176, 2176, 3296 };
	unsigned short mob6VRAM2[] = { 3296, 2176, 2176, 1216, 17376, 33776, 34814, 32737, 4069, 32737, 34814, 34800, 17376, 1216, 2176, 2176, 3296 };
	int x;
	Screen *screen;

	screen = gray_getScreen();
	x = autres->mob.hauteurReelle + autres->mob.pos - camera;

	switch(autres->mob.type)
	{
		case 1 : ML_bmp_or_cl_buffer(				 mob1VRAM1, x, autres->mob.y, 24, 38,screen->VRAM1);	ML_bmp_or_cl_buffer(				mob1VRAM2, x, autres->mob.y, 24, 38,screen->VRAM2);	break;
		case 2 : ML_bmp_or_cl_buffer((unsigned char*)mob2VRAM1, x, autres->mob.y, 16, 29,screen->VRAM1); 	ML_bmp_or_cl_buffer((unsigned char*)mob2VRAM2, x, autres->mob.y, 16, 29,screen->VRAM2); break;
		case 3 : ML_bmp_or_cl_buffer((unsigned char*)mob3VRAM1, x, autres->mob.y, 16, 12, screen->VRAM1);	ML_bmp_or_cl_buffer((unsigned char*)mob3VRAM2, x, autres->mob.y, 16, 12, screen->VRAM2);break;
		case 4 : ML_bmp_or_cl_buffer((unsigned char*)mob4VRAM1, x, autres->mob.y, 24, 17, screen->VRAM1);	ML_bmp_or_cl_buffer((unsigned char*)mob4VRAM2, x, autres->mob.y, 24, 17, screen->VRAM2);break;
		case 5 : ML_bmp_or_cl_buffer((unsigned char*)mob5VRAM1, x, autres->mob.y, 16, 19, screen->VRAM1);	ML_bmp_or_cl_buffer((unsigned char*)mob5VRAM2, x, autres->mob.y, 16, 19, screen->VRAM2);break;
		case 6 : ML_bmp_or_cl_buffer((unsigned char*)mob6VRAM1, x, autres->mob.y, 16, 17, screen->VRAM1);	ML_bmp_or_cl_buffer((unsigned char*)mob6VRAM2, x, autres->mob.y, 16, 17, screen->VRAM2);break;
		default : break;
	}
}

void draw_ball(Ball ball, int camera)
{
	unsigned char balleVRAM1[] = {224, 224, 224};
	unsigned char balleVRAM2[] = {224, 224, 224};
	Screen *screen;
	screen = gray_getScreen();

	if(ball.active)
	{
		ML_bmp_or_buffer(balleVRAM1, ball.x-camera, ball.y, 3, 3, screen->VRAM1);
		ML_bmp_or_buffer(balleVRAM2, ball.x-camera, ball.y, 3, 3, screen->VRAM2);
	}
}

void draw_etoiles(Doodle *doodle)
{
	unsigned char etoiles[3][11] = { {0,2,39,114,32,0,4,78,228,64,0},
	{4,14,4,64,224,66,7,2,32,112,32},
	{16,56,16,2,7,66,224,64,8,28,8} };
	Screen* screen;
	screen = gray_getScreen();

	ML_bmp_or_cl_buffer(etoiles[doodle->dead-1], doodle->saut.origine+doodle->saut.hauteur +12 - doodle->posCamera, doodle->y, 8, 11, screen->VRAM1);
	ML_bmp_or_cl_buffer(etoiles[doodle->dead-1], doodle->saut.origine+doodle->saut.hauteur +12 - doodle->posCamera, doodle->y, 8, 11, screen->VRAM2);
}
