#include <stdlib.h>
#include <fxlib.h>

#include "jeu.h"
#include "collisions.h"
#include "syscall.h"
#include "fonctions.h"
#include "struc.h"
#include "gray.h"
#include "plates.h"
#include "fakes.h"
#include "noob.h"
#include "key.h"

int pause(int score)
{
	unsigned short pause[] = {57344, 65408, 8176, 1648, 1584, 1584, 1584, 1584, 1840, 1008, 480, 28672, 64000, 51968, 51584, 18816, 63872, 65408, 3840, 0,28672,65408,
	53120, 49152, 49152, 24576, 61440, 65408, 3968, 0, 24576, 59136, 53120, 52608, 56704, 63872, 29568, 768, 0, 15872, 32512, 60800, 52608, 52608, 52608, 28544, 12032};
	unsigned char scoreImg[] = {64, 206, 159, 153, 249, 115, 2, 120,
							248, 132, 204, 76, 0, 112, 248, 140,
							196, 124, 56, 0, 224, 252, 28, 8, 4,
							112, 252, 164, 188, 56, 0, 0, 0, 0,
							192, 204, 12};
	Screen *screen;
	screen = gray_getScreen();
	gray_clearVRAM();
	ML_bmp_or_buffer((unsigned char*)pause, 95, 8, 12, 47, screen->VRAM1);
	ML_bmp_or_buffer((unsigned char*)pause, 95, 8, 12, 47, screen->VRAM2);
	ML_bmp_or_buffer(scoreImg, 65, 13, 8, 37, screen->VRAM1);
	ML_bmp_or_buffer(scoreImg, 65, 13, 8, 37, screen->VRAM2);

	afficher_nombres_buffer(score, 55, 20, screen->VRAM1);
	afficher_nombres_buffer(score, 55, 20, screen->VRAM2);
	gray_swapBuffers();
	gray_clearVRAM();

	while(KeyDown(K_MENU));// on arrete d'appuyer sur MENU

	while( !KeyDown(K_EXE) && !KeyDown(K_MENU))
	{
		if(KeyDown(K_EXIT))
			return 1;
		Sleep(50);// on economise les piles
	}
	while(KeyDown(K_MENU));
	while(KeyDown(K_EXE));
	return 0;
}
int jeu(int* score, unsigned char keyLeft, unsigned char keyRight, unsigned char shoot, unsigned char* contrast)
{
	int i, ancienLevel = 0;
	char downF5=0, downF6=0;
	Plate* listePlates = NULL;
	PlateFake* listeFakes = NULL;
	Doodle doodle;
	Autres autres;
	unsigned int tempsOrigine, frame=0, tempsEcart, fps=0;
	unsigned int tempsMob, tempsBall, tempsPlates;

	initialiseDoodle(&doodle);
	changer_level(0, &autres);
	/*autres.platesTempo.nbRestants = 4;*/
	listePlates = initialise_plates(listePlates);
	listeFakes = initialise_fakes(listeFakes);

	tempsPlates = tempsBall = tempsOrigine = tempsMob = RTC_GetTicks();
	gray_clearVRAM();
	//doodle.bouclier = 1;
	// vram 1 : gris fonce, vram 2 : gris clair
	while(1)
	{
		if(KeyDown(keyLeft))
		{
			doodle.y -=1 ;
			doodle.dernierAppui = GAUCHE;
				if(doodle.y <-5) doodle.y=59;
		}
		if(KeyDown(keyRight))
		{
			doodle.y +=1 ;
			doodle.dernierAppui = DROITE;
			if(doodle.y >59)doodle.y = -5;
		}
		if(KeyDown(K_F5))
		{
			if(downF5 == 0)
			{
				*contrast -=1;
				ML_set_contrast(*contrast);
				downF5 = 1;
			}
		}
		else
			downF5 = 0;
		if(KeyDown(K_F6))
		{
			if(downF6 == 0)
			{
				*contrast +=1;
				ML_set_contrast(*contrast);
				downF6 = 1;
			}
		}
		else
			downF6 = 0;
		if ( KeyDown(shoot) && doodle.ball.active == 0)
		{
			doodle.tire = 1;
			doodle.ball.active = 1;
			doodle.ball.x = doodle.saut.origine + doodle.saut.hauteur+15;
			doodle.ball.y = doodle.y + 3;
		}
		else
			doodle.tire = 0;
		if( KeyDown(K_MENU) )//menu pause
		{
			if(pause(doodle.score))
				return 1;
		}

		if( KeyDown(K_EXIT) )//ATTENTION, on ne supprime pas les plateformes(mais reset de la ram)
			return 1;

		doodle.level = (int) (doodle.score / 2000);// 1 level tous les 2000 points
		if(ancienLevel != doodle.level)
		{
			changer_level(doodle.level, &autres);
			ancienLevel = doodle.level;
		}

		collisions_doodle(&doodle, listePlates, &autres, 2, 4);
		collisions_fakes(listeFakes, &doodle);
		sauter_doodle(&(doodle.saut));
		deplacer_camera(&doodle);
		creer_plates(listePlates, listeFakes, doodle.posCamera, doodle.level, doodle.score, &autres);
		listePlates =  deplacerPlates(listePlates);

		if(RTC_GetTicks() - tempsOrigine >= 32 )//si 1/4 de seconde s'est ecouler
		{
			fps = frame*4;
			frame = 0;
			tempsOrigine = RTC_GetTicks();
		}
		frame++;
		if( RTC_GetTicks() - tempsMob >= 4 )
		{
			actualiser_mob(&autres);
			if(doodle.bouclier)
				doodle.bouclier +=1;
			if(doodle.bouclier >= 256)
				doodle.bouclier = 0;
			tempsMob = RTC_GetTicks();
		}
		if( RTC_GetTicks() - tempsBall >= 1 )
		{
			update_ball(&doodle);
			tempsBall = RTC_GetTicks();
		}
		if(RTC_GetTicks() - tempsPlates >= 8)
		{
			listePlates = actualiserPlates(listePlates);
			tempsPlates = RTC_GetTicks();
		}
		listePlates = supprimerPlates(listePlates, doodle.posCamera);
		listeFakes = supprimerFakes(listeFakes, doodle.posCamera);
		afficher(&doodle, listePlates, listeFakes, &autres, *contrast, fps);
		if(doodle.saut.origine + doodle.saut.hauteur < doodle.posCamera)// si le doodle va trop bas
			break;


		gray_swapBuffers();
		gray_clearVRAM();
		for(i=0; i<27000; i++);
		for(i=0; i<6000; i++);
	}

	*score = doodle.score;
	game_over(doodle.score, doodle.saut.origine + doodle.saut.hauteur, doodle.y, doodle.dead, doodle.posCamera, listePlates);
	while( listePlates = supprimerElementEnTete(listePlates));// on supprime les plateformes


	return 0;
}

void initialiseDoodle(Doodle* doodle)
{
	doodle->x = 0;
	doodle->y = 30;
	doodle->posCamera = 0;
	doodle->saut.position = -51;
	doodle->saut.hauteur = 0;
	doodle->saut.origine = 0;
	doodle->saut.modeSaut = NORMAL;
	doodle->dernierAppui = DROITE;
	doodle->score = 0;
	doodle->level = 0;
	doodle->bouclier = 0;
	doodle->tire = 0;
	doodle->dead = 0;
	doodle->ball.active = 0;
}

int sauter_doodle(Saut* sautDoodle)
{
	sautDoodle->position += 1;
	if(sautDoodle->modeSaut == NORMAL)
	{
		if(sautDoodle->position > 50)
			sautDoodle->hauteur -= 2;
		else
			sautDoodle->hauteur = 50-0.02*(sautDoodle->position)*(sautDoodle->position);// fonction 50-0.02x²
	}
	if(sautDoodle->modeSaut == RESSORT || sautDoodle->modeSaut == JET)
	{
		if(sautDoodle->position >= 0)// si on arrive en haut, on revient en normal
		{
			sautDoodle->modeSaut = NORMAL;
			sautDoodle->position = -51;
		}
		else
		{
			sautDoodle->origine += 2;
			sautDoodle->hauteur = 0;
		}

	}
	return 0;
}



void deplacer_camera(Doodle* doodle)
{
	int i;
	i = doodle->saut.origine + doodle->saut.hauteur - doodle->posCamera -70;

	if( i > 0)// si la position du doodle superieur a 70, on monte la camera
	{
		doodle->posCamera +=  i;
		doodle->score += i;
	}
}

int changer_level(int level, Autres* autres)// (rand() % (MAX - MIN + 1)) + MIN;
{
	int tmp;
	switch(level)
	{
		case 0:
		case 1:
		case 2:
		case 3:
			autres->var = (2000*level) + (rand() % (2000-100+1)) + 100;
			break;
		default : break;
	}

	if (!(level&1))//si level est pair
	{
		autres->platesTempo.x = (2000*level) + (rand() % (2000-100+1)) + 100;
		//autres->platesTempo.x = (2000*level) + 300;
		autres->platesTempo.nbRestants = level+4;
	}
	autres->mob.hauteur = (2000*level) + (rand() % (2000 - 200+ 1)) + 0;
	//autres->mob.hauteur = (2000*level) + 300;
	autres->mob.hauteurReelle = 0;
	autres->mob.width = 38;
	autres->mob.vecteur = 1;
	autres->mob.y = 0;
	autres->mob.pos = 0;
	autres->mob.vecteurX = 1;
	autres->mob.type = (rand()%(6) + 1);
	autres->mob.bouclier = 0;
	//autres->mob.type = 6;

	return 0;
}


void actualiser_mob(Autres* autres)
{
	char heightMobs[] = {38, 29, 12, 19, 17, 16};

	autres->mob.pos += autres->mob.vecteurX;
	if(autres->mob.pos >= 4 || autres->mob.pos <= -4)
		autres->mob.vecteurX = -autres->mob.vecteurX;

	autres->mob.y += autres->mob.vecteur;

	if(autres->mob.y +  heightMobs[autres->mob.type-1] >= 64 || autres->mob.y <= 0)
		autres->mob.vecteur = - autres->mob.vecteur;
}

void update_ball(Doodle* doodle)
{
	if(doodle->ball.active)
	{
		doodle->ball.x +=2;
		if(doodle->ball.x - doodle->posCamera > 128)
		{
			doodle->tire = 0;
			doodle->ball.active =0;
		}
	}
}

