#include <stdlib.h>
#include "fxlib.h"

#include "plates.h"
#include "struc.h"
//#include "fakes.h"
#include "gray.h"
#include "syscall.h"



Plate* initialise_plates(Plate* liste)
{
	liste = ajouterEnFin(liste, 15, 30);
	liste->nxt = NULL;
	return liste;
}

Plate* ajouterEnFin(Plate* liste, int x, int y)
{
    Plate* nouvelElement = NULL;// On cree un nouvel element
	Plate* tmp = NULL;
	int i;
	nouvelElement = malloc(sizeof(Plate));
	tmp = liste;

    nouvelElement->x = x; // On assigne les valeurs aux nouveaux elements
    nouvelElement->y = y;
	nouvelElement->ressort = 0;
	nouvelElement->vecteur = 0.0;
	nouvelElement->doubleY = y;
	nouvelElement->mode = NORMALE;
	nouvelElement->positionTempo = 0;
	nouvelElement->tempo = 0;
	nouvelElement->bouclier = 0;
	for(i=1; i<47; i++)
		nouvelElement->pixelsTempo[i] = 1;
	nouvelElement->pixelsTempo[0] = 0;
	nouvelElement->pixelsTempo[11] = 0;
	nouvelElement->pixelsTempo[36] = 0;
	nouvelElement->pixelsTempo[47] = 0;
    nouvelElement->nxt = NULL; // On ajoute rien a la fin

    if(!liste)
        return nouvelElement;// Si la liste est vide il suffit de renvoyer l'element cree .

    tmp = liste;
    while(tmp->nxt)
        tmp = tmp->nxt;

    tmp->nxt = nouvelElement;
    return liste;
}

Plate* creer_plates(Plate* listePlates, PlateFake* plateFakes, int posCamera, int level, int score, Autres* autres)// (rand() % (MAX - MIN + 1)) + MIN;
{
	Plate* tmp;
	int max=0;

	tmp = listePlates;
	max = tmp->x;

	while(tmp->nxt)// calcul de la hauteur max des plateformes
	{
		tmp = tmp->nxt;
		if(tmp->x > max)
			max = tmp->x ;
	}

	while(max < posCamera + 128 || tmp->mode == TEMPORISEE)// si toutes les plateformes sont a l'interieur de l'ecran, on en cree autant qu'il en faut (pour qu'il y en ait une qui soit en dehors de l'ecran)
	{
		tmp->nxt = creer_plates_level(level, score, &max, autres);
		creer_fakes(tmp, plateFakes, 2);
		tmp = tmp->nxt;
	}

	return listePlates;
}


Plate* creer_plates_level(int level, int score, int* max, Autres* autres)// creer les plateformes en fonction du niveau
{
	Plate* nouvelElement;
	int i, xMini;
	nouvelElement = malloc(sizeof(Plate));
	if(nouvelElement == NULL)
		reset_calc();

	if( score >= autres->mob.hauteur && autres->mob.hauteur)//si on arrive a la hauteur du mob
	{
		autres->mob.hauteurReelle = *max +10;
		*max = *max +36;
		autres->mob.hauteur = 0;//hauteur est a 0 quand le mob est cree
	}
	else// condition normale
	{
		xMini = 10+level;
		if(xMini > 20)
			xMini = 20;
		*max = *max + (rand() % (15)) + xMini;//pour level = 0, la plateforme sera entre 10 et 25 pixels au-dessus, level >= 10 -> plate entre 20 et 35
		//*max = *max + (rand() % (25 - 7 + 1)) + 7;
	}

	nouvelElement->x = *max;
	nouvelElement->y = (rand() % (63-LARGEUR_PLATEFORME )) + 1;
	nouvelElement->ressort = 0;
	nouvelElement->vecteur = 0.0;
	nouvelElement->tempo = 0;
	nouvelElement->doubleY = (double) nouvelElement->y;
	nouvelElement->mode = NORMALE;
	nouvelElement->positionTempo = 0;
	nouvelElement->tempo = 0;
	nouvelElement->bouclier = 0;
	nouvelElement->nxt = NULL;
	if(score >= autres->mob.hauteur-200 && autres->mob.hauteur && autres->mob.bouclier ==0)
	{
		nouvelElement->bouclier = 1;
		autres->mob.bouclier = 1;
	}

	if(*max > autres->platesTempo.x && autres->platesTempo.nbRestants >0)
	{
		i=0;
		nouvelElement->mode = TEMPORISEE;
		autres->platesTempo.nbRestants -=1;
		if(autres->platesTempo.nbRestants == 0)
		{
			autres->platesTempo.x = 0;
			//nouvelElement->nxt = creer_plates_level(level, score, max, autres);//on veut creer une plateforme normale
		}
		nouvelElement->tempo = 1;
		for(i=1; i<47; i++)
			nouvelElement->pixelsTempo[i] = 1;
		nouvelElement->pixelsTempo[0] = 0;
		nouvelElement->pixelsTempo[11] = 0;
		nouvelElement->pixelsTempo[36] = 0;
		nouvelElement->pixelsTempo[47] = 0;
		return nouvelElement;
	}
	else if(*max > autres->var && autres->var && nouvelElement->bouclier ==0) // si on arrive aux coordonnes d'un jetpack
	{
		nouvelElement->mode = JETPACK;// on creer une plateforme avec un jetpack
		autres->var = 0;//on desactive le jetpack
		return nouvelElement;
	}

	if( (rand()%(100))+1 <= ((int)(9.6*level)) +4 ) // 9.6x+4 : probabilite d'avoir une plate qui bouge. si (level >10) -> 100% de prob. 4% au niveau 0
		nouvelElement->vecteur = (double)(1+ ((int) (score/2000))) /10;

	if((rand() % (25)) + 1 == 1)//1chance sur 25 d'avoir un ressor
		nouvelElement->ressort = (rand()%(2)) + 1;
	if((rand() % (100)) + 1 <= level+1) // (level+1) chance sur 100 d'avoir une ponctuelle
		nouvelElement->mode = PONCTUELLE;

	return nouvelElement;
}

Plate* supprimerPlates(Plate* liste, int posCamera)
{
	Plate* tmp = NULL;
    if(liste == NULL)// Liste vide, il n'y a plus rien à supprimer
        return NULL;
    if(liste->x + HAUTEUR_PLATEFORME < posCamera)// Si l'element  doit être supprime
    {

        tmp = liste->nxt;
        free(liste);
        tmp = supprimerPlates(tmp, posCamera);
        return tmp;
    }
    else
    {
        liste->nxt = supprimerPlates(liste->nxt, posCamera);
        return liste;
    }
}



Plate* deplacerPlates(Plate* liste)// pour les plateformes qui bougent
{
	Plate* tmp;
	tmp = liste;

    while(tmp)
    {
		if(tmp->vecteur)
		{
			tmp->doubleY += tmp->vecteur;
			tmp->y = tmp->doubleY;
			if(tmp->y <1 || tmp->y > 64-LARGEUR_PLATEFORME)
				tmp->vecteur = - tmp->vecteur;
		}
		tmp = tmp->nxt;
	}

    return liste;
}

Plate* actualiserPlates(Plate* liste)
{
	Plate* tmp;
	int i,temp,i2;
	tmp = liste;
	while(tmp)
    {
		if(tmp->mode == TEMPORISEE)
		{

			if(tmp->tempo == 128)// si on a atteint la duree de temporisation
				tmp->positionTempo = 0;
			else if(tmp->tempo > 128)
			{
				temp = rand()%(44 - (tmp->positionTempo)) + 1;
				for(i=0, i2=0; i2 != temp; i++)
				{
					if(tmp->pixelsTempo[i] == 1)
						i2 ++;
				}
				tmp->pixelsTempo[i-1] = 0;
				tmp->positionTempo += 1;
			}
			if(tmp->positionTempo == 44)
			{
				tmp->x = -10;// on met la plateforme en dessous de la camera pour qu'elle soit supprimee
				//tmp->mode = PONCTUELLE;
			}
			tmp->tempo += 1;
		}
		tmp = tmp->nxt;
	}
	return liste;
}

Plate* supprimerElementEnTete(Plate* liste)
{
	Plate* aRenvoyer = NULL;
    if(liste)
    {
		aRenvoyer = liste->nxt; /* Si la liste est non vide, on se prepare à renvoyer l'adresse de l'element en 2ème position */
        free(liste); /* On libère le premier element */
        return aRenvoyer; /* On retourne le nouveau debut de la liste */
    }
    return NULL;
}

PlateFake* initialise_fakes(PlateFake* liste)
{
	liste = malloc(sizeof(PlateFake));

	liste->origine = 10;
	liste->position = 0;
	liste->y = 0;
	liste->actif = 0;
	liste->nxt = NULL;

	return liste;
}

void creer_fakes(Plate* tmp, PlateFake* platesFakes, int var)
{
	Plate* tmpe;
	PlateFake* newP = NULL;
	PlateFake* tmpa;
	tmpe = tmp->nxt;
	tmpa = platesFakes;

	while(tmpa->nxt)
		tmpa = tmpa->nxt;

	newP = malloc(sizeof(PlateFake));
	if(newP == NULL)
		reset_calc();

	newP->origine = 4+ (tmp->x) +(rand()%(tmpe->x-tmp->x-8 )) ;
	newP->y = (rand()%(51)) + 1;
	newP->position = 0;
	if(rand()%3 == 1)
		newP->actif = 1;
	else
		newP->actif = 0;
	newP->nxt = NULL;

	tmpa->nxt = newP;
}


PlateFake* supprimerFakes(PlateFake* liste, int posCamera)
{
	PlateFake* tmp = NULL;
    if(liste == NULL)// Liste vide, il n'y a plus rien à supprimer
        return NULL;
    if(liste->origine + 4 < posCamera)// Si l'element  doit être supprime
    {

        tmp = liste->nxt;
        free(liste);
        tmp = supprimerFakes(tmp, posCamera);
        return tmp;
    }
    else
    {
        liste->nxt = supprimerFakes(liste->nxt, posCamera);
        return liste;
    }

}

